/* 
    File: ISTest8.C
	 Example fore DeleteRow, RemoveRow, CompressTable
	 DeleteRow marks row as deleted, RemoveRow removes row phisicaly
	 CompressTable removes all deleted rows and recreates indices
*/

#include <string>
#include <iostream>

#include "ISTable.h"

using namespace std;


// prototypes

void FillTestTable(ISTable *s);
void PrintArray(vector<int> * target);

int main(int argc, char** argv) {

  ISTable *ss1;
  ISTable *ss2;

  ss1 = new ISTable();
  ss2 = new ISTable();

  FillTestTable(ss1);
  FillTestTable(ss2);

  ss1->DeleteRow(7);
  ss1->DeleteRow(5);
  ss1->DeleteRow(3);

  cout<<ss1->GetNumRows()<<endl;

  ss2->DeleteRow(7);
  ss2->DeleteRow(5);
  ss2->DeleteRow(3);
  cout<<ss2->GetNumRows()<<endl;

  cout << (*ss1);
  cout << (*ss2);

  delete ss1;
  delete ss2;
  exit(0);
}


void FillTestTable(ISTable *s) {
 int i;
 vector<string>* ColStart;
 vector<string>* ColEnd;
 vector<string>* ColLen;
 ColStart = new vector<string>;
 ColEnd = new vector<string>;
 ColLen = new vector<string>;
 string length;
 char a[5];
 s->AddColumn("start_v");
 s->AddColumn("end_v");
 s->AddColumn("lp_lenght");
 for (i=0; i<10; i++) {
   sprintf(a,"%d",49-i);
   length = a;
	ColStart->push_back(length);
   sprintf(a,"%d",i);
   length = a;
	ColEnd->push_back(length);
	ColLen->push_back(length);
 }

 s->FillColumn("start_v", *ColStart);
 s->FillColumn("end_v", *ColEnd);
 s->FillColumn("lp_lenght", *ColLen);

 delete ColStart;
 delete ColEnd;
 delete ColLen;
}



void PrintArray(vector<int> * target) {
  if (target) {
    int len = target->size();
    for (int i = 0; i < len - 1; i++) {
      cout << (*target)[i] << ", ";
    }
    if (len > 0)
      cout << (*target)[len - 1];
  }
  cout << endl;
}
